# Coveo ResultsPerPage Component (CoveoResultsPerPage)

The ResultsPerPage component attaches itself to a `div` and allows the end user to choose how many results to display per page.

Note: Adding a ResultPerPage component to your page overrides the value of SearchInterface.options.resultsPerPage.

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- setResultsPerPage
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- resultsPerPage
- usageAnalytics

### Component Options

- choicesDisplayed
- initialChoice

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### setResultsPerPage

- setResultsPerPage(resultsPerPage: number, analyticCause?: IAnalyticsActionCause): void

- - Defined in ui/ResultsPerPage/ResultsPerPage.ts :115

  Sets the current number of results per page, then executes a query.

  Also logs an event in the usage analytics (`pagerResize` by default) with the new current number of results per page as meta data.

  #### Parameters

  - ##### resultsPerPage: number

    The new number of results per page to select.

  - ##### Default value analyticCause: IAnalyticsActionCause = analyticsActionCauseList.pagerResize

    The event to log in the usage analytics.

  #### Returns void

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### resultsPerPage

- get (): number

- - Defined in ui/ResultsPerPage/ResultsPerPage.ts :128

  Returns the current number of results per page.

  #### Returns number

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### choicesDisplayed

choicesDisplayed: number[]

- Defined in ui/ResultsPerPage/ResultsPerPage.ts :55

Specifies the possible values of number of results to display per page that the end user can select from.

See also ResultsPerPage.options.initialChoice.

Default value is `[10, 25, 50, 100]`.

### initialChoice

initialChoice: number

- Defined in ui/ResultsPerPage/ResultsPerPage.ts :77

Specifies the value to select by default for the number of results to display per page.

Default value is the first value of ResultsPerPage.options.choicesDisplayed.

Markup configuration example(s) :

    data-initial-choice='10'

## Constructors

### constructor

- new ResultsPerPage(element: HTMLElement, options?: IResultsPerPageOptions, bindings?: IComponentBindings): ResultsPerPage

- Overwrites Component.constructor

  - Defined in ui/ResultsPerPage/ResultsPerPage.ts :82

  Creates a new ResultsPerPage. The component renders itself on every query success.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component (normally a `div`).

  - ##### Optional options: IResultsPerPageOptions

    The options for the ResultsPerPage component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns ResultsPerPage